package john111898.ld29.entity;

import java.awt.image.BufferedImage;

import john111898.ld29.collision.CollisionBox;
import john111898.ld29.render.Renderable;

public class Entity implements Renderable {
	int x = 0;
	int y = 0;
	BufferedImage image;
	
	CollisionBox collision;
	
	public Entity(BufferedImage image, int x, int y) {
		this.image = image;
		this.x = x;
		this.y = y;
		collision = createCollisionBox();
	}
	
	@Override
	public int getX() {
		return x;
	}

	@Override
	public int getY() {
		return y;
	}

	@Override
	public BufferedImage getImage() {
		return image;
	}
	
	public void setX(int x) {
		this.x = x;
	}
	
	public void setY(int y) {
		this.y = y;
	}
	
	public CollisionBox createCollisionBox() {
		double width = image.getWidth();
		double height = image.getHeight();
		return new CollisionBox(width, height);
	}
	
	public void updateCollisionCoords(int x, int y) {
		collision.x = x;
		collision.y = y;
	}
}