package john111898.ld29.entity;

import java.awt.image.BufferedImage;

import john111898.ld29.Game;
import john111898.ld29.collision.CollisionBox;

public class EntityPlayer extends Entity {
	int height = image.getHeight();
	int x = 0;
	int y = 0;
	public int renderX = Game.WIDTH / 2;
	
	double verticalVelocity = 0.0;
	double horizontalVelocityPositive = 0.0;
	double horizontalVelocityNegative = 0.0;
	
	public EntityPlayer(BufferedImage image, int x, int y) {
		super(image, x, y);
	}
	
	public int getHeight() {
		return height;
	}
	
	@Override
	public int getX() {
		return renderX;
	}
	
	public void setX(int x) {
		this.x = x;
	}
	
	public int getLogicX() {
		return x;
	}
	
	public void setRenderX(int rX) {
		this.renderX = rX;
	}
	
	public void setVerticalVelocity(double v) {
		verticalVelocity = v;
	}
	
	public double getVerticalVelocity() {
		return verticalVelocity;
	}
	
	public void updateHeight() {
		this.setY((int) (this.getY() - verticalVelocity));
	}
	
	public void setHorizontalVelocityPositive(double hv) {
		horizontalVelocityPositive = hv;
	}
	
	public double getHorizontalVelocityPositive() {
		return horizontalVelocityPositive;
	}
	
	public void updateX() {
		setX((int) (x + horizontalVelocityPositive - horizontalVelocityNegative));
	}
	
	public void setHorizontalVelocityNegative(double hv) {
		horizontalVelocityNegative = hv;
	}
	
	public double getHorizontalVelocityNegative() {
		return horizontalVelocityNegative;
	}
	
	public CollisionBox getCollisionBox() {
		return collision;
	}
}