package john111898.ld29.level;

import john111898.ld29.Game;
import john111898.ld29.entity.EntityPlayer;
import john111898.ld29.render.Renderable;
import john111898.ld29.world.GameObject;
import john111898.ld29.world.ObjectCounter;
import john111898.ld29.world.Vacuum;

public class LevelFour extends Level {
	boolean soundPlayed = false;
	
	public LevelFour() {
		super(4, -150000);
	}
	
	@Override
	public void checkForPitOpen() {
		ObjectCounter oc = null;
		for (int i = 0; i < renderables.size(); i++) {
			if (renderables.get(i) instanceof ObjectCounter) {
				oc = (ObjectCounter) renderables.get(i);
			}
		}
		if (oc != null) {
			oc.countObjects();
			if (oc.hasNumNeeded()) {
				Game.levelGround.setPitOpen(true);
				if (!soundPlayed) {
					soundPlayed = true;
					Game.playSound(0);
				}
			}
		}
	}
	
	@Override
	public void updateGameObjects(EntityPlayer player) {
		for (int i = 0; i < renderables.size(); i++) {
			Renderable r = renderables.get(i);
			if (r instanceof GameObject) {
				GameObject go = (GameObject) r;
				if (go.isHeldByPlayer()) {
					go.setLogicX(player.getLogicX() + 8);
					go.updateRenderX();
					go.setY(player.getY() - 16);
				}
				go.updateRenderX();
				
				if (!go.isHeldByPlayer() && go.affectedByGravity()) {
					if (go.getY() < verticalCollide(go) - go.getImageHeight()) {
						go.setVerticalVelocity(go.getVerticalVelocity() - 0.25);
					}
					else {
						go.setVerticalVelocity(0.0);
					}
					go.updateHeight();
					
					if (objectCollideSide(go) == go.getX()) {
						go.setLogicX(go.getLogicX() - 16);
					}
					else {
						if (objectCollideSide(go) != 0) {
							go.setLogicX(go.getLogicX() - 16);
						}
					}
				}
				
			}
			if (r instanceof ObjectCounter) {
				ObjectCounter oc = (ObjectCounter) r;
				oc.countObjects();
			}
			if (r instanceof Vacuum) {
				Vacuum v = (Vacuum) r;
				v.attractObjects();
			}
		}
	}
}