package john111898.ld29.level;

import john111898.ld29.Game;
import john111898.ld29.render.DefaultRenderable;
import john111898.ld29.world.ClickableButton;
import john111898.ld29.world.ClickableButton6Grav;
import john111898.ld29.world.ClickableButton6NoGrav;
import john111898.ld29.world.ClickableButtonDropBox7;
import john111898.ld29.world.ClickableButtonDropObject;
import john111898.ld29.world.ClickableButtonDropVacuum;
import john111898.ld29.world.ClickableButtonDropVacuumNoGrav;
import john111898.ld29.world.GameObject;
import john111898.ld29.world.Ground;
import john111898.ld29.world.ObjectCounter;
import john111898.ld29.world.ObjectCounter6;
import john111898.ld29.world.ObjectCounter7;
import john111898.ld29.world.ObjectCounterOnlyAbove;
import john111898.ld29.world.Vacuum;
import john111898.ld29.world.WorldBlock;

public class LevelGenerator {
	public static Level tutorial() {
		LevelTutorial tutorial = new LevelTutorial();
		DefaultRenderable background = new DefaultRenderable(Game.images[11]);
		tutorial.setBackground(background);
		Ground g = new Ground(100, Game.images[12], 6000);
		tutorial.setGround(g);
		ClickableButton cb = new ClickableButton(1432, 206);
		GameObject box1 = new GameObject(2400, 285, Game.images[4], true);
		box1.setAffectedByGravity(true);
		GameObject box2 = new GameObject(5137, 285, Game.images[4], true);
		box2.setAffectedByGravity(true);
		GameObject box3 = new GameObject(5172, 285, Game.images[4], true);
		box3.setAffectedByGravity(true);
		ObjectCounter oc = new ObjectCounter(5386, Game.HEIGHT - 132, Game.images[9], 2);
		Vacuum v = new Vacuum(3750, Game.HEIGHT - 132, Game.images[15], Vacuum.DIRECTION_UP);
		tutorial.addRenderable(background);
		tutorial.addRenderable(g);
		tutorial.addRenderable(cb);
		tutorial.addRenderable(box1);
		tutorial.addRenderable(box2);
		tutorial.addRenderable(box3);
		tutorial.addRenderable(oc);
		tutorial.addRenderable(v);
		
		return tutorial;
	}
	
	public static Level levelOne() {
		LevelOne lvl1 = new LevelOne();
		DefaultRenderable background = new DefaultRenderable(Game.images[1]);
		lvl1.setBackground(background);
		Ground g = new Ground(200, Game.images[2], 1900);
		lvl1.setGround(g);
		WorldBlock block1 = new WorldBlock(700, 232 - 80, Game.images[13]);
		WorldBlock block2 = new WorldBlock(700, 264 - 80, Game.images[13]);
		WorldBlock block3 = new WorldBlock(700, 296 - 80, Game.images[13]);
		WorldBlock block4 = new WorldBlock(700, 328 - 80, Game.images[13]);
		WorldBlock block5 = new WorldBlock(732, 232 - 80, Game.images[13]);
		WorldBlock block6 = new WorldBlock(732, 264 - 80, Game.images[13]);
		WorldBlock block7 = new WorldBlock(732, 296 - 80, Game.images[13]);
		WorldBlock block8 = new WorldBlock(732, 328 - 80, Game.images[13]);
		ClickableButtonDropObject button1 = new ClickableButtonDropObject(475, 200, 4);
		ClickableButtonDropObject button2 = new ClickableButtonDropObject(1400, 200, 2);
		ObjectCounter counter = new ObjectCounter(1700, Game.HEIGHT - 232, Game.images[9], 6);
		lvl1.addRenderable(background);
		lvl1.addRenderable(g);
		lvl1.addRenderable(block1);
		lvl1.addRenderable(block2);
		lvl1.addRenderable(block3);
		lvl1.addRenderable(block4);
		lvl1.addRenderable(block5);
		lvl1.addRenderable(block6);
		lvl1.addRenderable(block7);
		lvl1.addRenderable(block8);
		lvl1.addRenderable(button1);
		lvl1.addRenderable(button2);
		lvl1.addRenderable(counter);
		lvl1.addNewRenderables();
		
		return lvl1;
	}
	
	public static Level levelTwo() {
		LevelTwo lvl2 = new LevelTwo();
		DefaultRenderable background = new DefaultRenderable(Game.images[7]);
		lvl2.setBackground(background);
		Ground g = new Ground(100, Game.images[8], 180);
		lvl2.setGround(g);
		WorldBlock block1 = new WorldBlock(500, 132 - 104, Game.images[14]);
		WorldBlock block2 = new WorldBlock(500, 196 - 104, Game.images[14]);
		WorldBlock block3 = new WorldBlock(500, 260 - 104, Game.images[14]);
		WorldBlock block4 = new WorldBlock(500, 324 - 104, Game.images[14]);
		WorldBlock block5 = new WorldBlock(500, 388 - 104, Game.images[14]);
		WorldBlock block6 = new WorldBlock(500, 452 - 104, Game.images[14]);
		ObjectCounterOnlyAbove oc = new ObjectCounterOnlyAbove(500, 164 - 104, Game.images[9], 8);
		ClickableButtonDropObject cb = new ClickableButtonDropObject(300, 180, 0);
		lvl2.addRenderable(background);
		lvl2.addRenderable(g);
		lvl2.addRenderable(block1);
		lvl2.addRenderable(block2);
		lvl2.addRenderable(block3);
		lvl2.addRenderable(block4);
		lvl2.addRenderable(block5);
		lvl2.addRenderable(block6);
		lvl2.addRenderable(oc);
		lvl2.addRenderable(cb);
		lvl2.addNewRenderables();
		
		return lvl2;
	}
	
	public static Level levelThree() {
		LevelThree lvl = new LevelThree();
		DefaultRenderable bg = new DefaultRenderable(Game.images[19]);
		lvl.setBackground(bg);
		Ground g = new Ground(150, Game.images[20], 150);
		lvl.setGround(g);
		Vacuum v1 = new Vacuum (500, 330, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v2 = new Vacuum (468, 170, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v3 = new Vacuum (500, 138, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v4 = new Vacuum (532, 138, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v5 = new Vacuum (564, 138, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v6 = new Vacuum (596, 138, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v7 = new Vacuum (628, 138, Game.images[15], Vacuum.DIRECTION_UP);
		Vacuum v8 = new Vacuum (660, 170, Game.images[15], Vacuum.DIRECTION_UP);
		WorldBlock w1 = new WorldBlock(468, 202, Game.images[21]);
		WorldBlock w2 = new WorldBlock(468, 234, Game.images[21]);
		WorldBlock w3 = new WorldBlock(468, 266, Game.images[21]);
		WorldBlock w4 = new WorldBlock(468, 298, Game.images[21]);
		WorldBlock w5 = new WorldBlock(468, 138, Game.images[21]);
		WorldBlock w6 = new WorldBlock(660, 138, Game.images[21]);
		WorldBlock w7 = new WorldBlock(660, 202, Game.images[21]);
		WorldBlock w8 = new WorldBlock(660, 234, Game.images[21]);
		WorldBlock w9 = new WorldBlock(660, 266, Game.images[21]);
		WorldBlock w0 = new WorldBlock(660, 298, Game.images[21]);
		GameObject o = new GameObject(300, 200, Game.images[4], true);
		o.setAffectedByGravity(true);
		ObjectCounter oc = new ObjectCounter(596, 298, Game.images[9], 2);
		lvl.addRenderable(bg);
		lvl.addRenderable(g);
		lvl.addRenderable(o);
		lvl.addRenderable(v1);
		lvl.addRenderable(v2);
		lvl.addRenderable(v3);
		lvl.addRenderable(v4);
		lvl.addRenderable(v5);
		lvl.addRenderable(v6);
		lvl.addRenderable(v7);
		lvl.addRenderable(v8);
		lvl.addRenderable(w1);
		lvl.addRenderable(w2);
		lvl.addRenderable(w3);
		lvl.addRenderable(w4);
		lvl.addRenderable(w5);
		lvl.addRenderable(w6);
		lvl.addRenderable(w7);
		lvl.addRenderable(w8);
		lvl.addRenderable(w9);
		lvl.addRenderable(w0);
		lvl.addRenderable(oc);
		lvl.addNewRenderables();
		
		return lvl;
	}
	
	public static Level levelFour() {
		LevelFour lvl = new LevelFour();
		DefaultRenderable bg = new DefaultRenderable(Game.images[22]);
		lvl.setBackground(bg);
		Ground g = new Ground(100, Game.images[23], 100);
		ClickableButtonDropVacuum cb = new ClickableButtonDropVacuum(400, 200, 4);
		WorldBlock w1 = new WorldBlock(500, 348, Game.images[24]);
		WorldBlock w2 = new WorldBlock(500, 316, Game.images[24]);
		WorldBlock w3 = new WorldBlock(500, 284, Game.images[24]);
		WorldBlock w4 = new WorldBlock(500, 252, Game.images[24]);
		WorldBlock w5 = new WorldBlock(500, 220, Game.images[24]);
		WorldBlock w6 = new WorldBlock(788, 348, Game.images[24]);
		WorldBlock w7 = new WorldBlock(788, 316, Game.images[24]);
		WorldBlock w8 = new WorldBlock(788, 284, Game.images[24]);
		WorldBlock w9 = new WorldBlock(788, 252, Game.images[24]);
		WorldBlock w0 = new WorldBlock(788, 220, Game.images[24]);
		ObjectCounter oc = new ObjectCounter(724, 380, Game.images[9], 25);
		lvl.setGround(g);
		lvl.addRenderable(bg);
		lvl.addRenderable(g);
		for (int i = 0; i < 5; i++) {
			for (int j = 0; j < 5; j++) {
				GameObject go = new GameObject(532 + (i * 32), 220 + (j * 32), Game.images[4], false);
				go.setAffectedByGravity(true);
				lvl.addRenderable(go);
			}
		}
		lvl.addRenderable(cb);
		lvl.addRenderable(w1);
		lvl.addRenderable(w2);
		lvl.addRenderable(w3);
		lvl.addRenderable(w4);
		lvl.addRenderable(w5);
		lvl.addRenderable(w6);
		lvl.addRenderable(w7);
		lvl.addRenderable(w8);
		lvl.addRenderable(w9);
		lvl.addRenderable(w0);
		lvl.addRenderable(oc);
		lvl.addNewRenderables();
		return lvl;
	}
	
	public static Level levelFive() {
		LevelFive lvl = new LevelFive();
		DefaultRenderable bg = new DefaultRenderable(Game.images[25]);
		lvl.setBackground(bg);
		Ground g = new Ground(150, Game.images[26], 1000);
		GameObject box = new GameObject(500, Game.HEIGHT - g.getGroundHeight() - 32, Game.images[4], true);
		box.setAffectedByGravity(true);
		ClickableButtonDropVacuum cb1 = new ClickableButtonDropVacuum(350, 200, 1);
		ClickableButtonDropVacuumNoGrav cb2 = new ClickableButtonDropVacuumNoGrav(400, 200, 1);
		WorldBlock b1 = new WorldBlock(700, 150, Game.images[31]);
		WorldBlock b2 = new WorldBlock(732, 150, Game.images[31]);
		ObjectCounterOnlyAbove oc = new ObjectCounterOnlyAbove(700, 118, Game.images[9], 1);
		lvl.setGround(g);
		lvl.addRenderable(bg);
		lvl.addRenderable(g);
		lvl.addRenderable(b1);
		lvl.addRenderable(b2);
		lvl.addRenderable(oc);
		lvl.addRenderable(box);
		lvl.addRenderable(cb1);
		lvl.addRenderable(cb2);
		lvl.addNewRenderables();
		return lvl;
	}
	
	public static Level levelSix() {
		LevelSix lvl = new LevelSix();
		DefaultRenderable bg = new DefaultRenderable(Game.images[27]);
		lvl.setBackground(bg);
		Ground g = new Ground(200, Game.images[28], 100);
		Vacuum v1 = new Vacuum (600, 248, Game.images[17], Vacuum.DIRECTION_LEFT, false, false);
		Vacuum v2 = new Vacuum (600, 216, Game.images[17], Vacuum.DIRECTION_LEFT, false, false);
		Vacuum v3 = new Vacuum (600, 184, Game.images[17], Vacuum.DIRECTION_LEFT, false, false);
		Vacuum v4 = new Vacuum (600, 152, Game.images[17], Vacuum.DIRECTION_LEFT, false, false);
		Vacuum v5 = new Vacuum (824, 248, Game.images[18], Vacuum.DIRECTION_RIGHT, false, false);
		Vacuum v6 = new Vacuum (824, 216, Game.images[18], Vacuum.DIRECTION_RIGHT, false, false);
		Vacuum v8 = new Vacuum (824, 152, Game.images[18], Vacuum.DIRECTION_RIGHT, false, false);
		ClickableButton6Grav cb1 = new ClickableButton6Grav(720, 50);
		ClickableButton6NoGrav cb2 = new ClickableButton6NoGrav(450, 150, 4);
		ObjectCounter6 oc = new ObjectCounter6(760, 280, Game.images[9], 1);
		lvl.setGround(g);
		lvl.addRenderable(bg);
		lvl.addRenderable(g);
		lvl.addRenderable(v1);
		lvl.addRenderable(v2);
		lvl.addRenderable(v3);
		lvl.addRenderable(v4);
		lvl.addRenderable(v5);
		lvl.addRenderable(v6);
		lvl.addRenderable(v8);
		lvl.addRenderable(cb1);
		lvl.addRenderable(cb2);
		lvl.addRenderable(oc);
		lvl.addNewRenderables();
		return lvl;
	}
	
	public static Level levelSeven() {
		LevelSeven lvl = new LevelSeven();
		DefaultRenderable bg = new DefaultRenderable(Game.images[29]);
		lvl.setBackground(bg);
		Ground g = new Ground(100, Game.images[30], 250);
		ObjectCounter7 oc1 = new ObjectCounter7(800, 380, Game.images[9], 5, 0);
		ObjectCounter7 oc2 = new ObjectCounter7(864, 380, Game.images[9], 5, 1);
		ObjectCounter7 oc3 = new ObjectCounter7(928, 380, Game.images[9], 5, 2);
		ObjectCounter7 oc4 = new ObjectCounter7(992, 380, Game.images[9], 5, 3);
		ObjectCounter7 oc5 = new ObjectCounter7(1056, 380, Game.images[9], 5, 4);
		ClickableButtonDropBox7 cb1 = new ClickableButtonDropBox7(768 - 8, 180, 5);
		ClickableButtonDropBox7 cb2 = new ClickableButtonDropBox7(832 - 8, 180, 5);
		ClickableButtonDropBox7 cb3 = new ClickableButtonDropBox7(896 - 8, 180, 5);
		ClickableButtonDropBox7 cb4 = new ClickableButtonDropBox7(960 - 8, 180, 5);
		ClickableButtonDropBox7 cb5 = new ClickableButtonDropBox7(1024 - 8, 180, 5);
		ClickableButtonDropVacuum cb6 = new ClickableButtonDropVacuum(500, 180, 1);
		lvl.setGround(g);
		lvl.addRenderable(bg);
		lvl.addRenderable(g);
		lvl.addRenderable(oc1);
		lvl.addRenderable(oc2);
		lvl.addRenderable(oc3);
		lvl.addRenderable(oc4);
		lvl.addRenderable(oc5);
		lvl.addRenderable(cb1);
		lvl.addRenderable(cb2);
		lvl.addRenderable(cb3);
		lvl.addRenderable(cb4);
		lvl.addRenderable(cb5);
		lvl.addRenderable(cb6);
		lvl.addNewRenderables();
		return lvl;
	}
}