package john111898.ld29.level;

import java.awt.Color;

import john111898.ld29.Game;
import john111898.ld29.entity.EntityPlayer;
import john111898.ld29.render.Renderable;
import john111898.ld29.world.GameObject;
import john111898.ld29.world.ObjectCounter7;
import john111898.ld29.world.Vacuum;

public class LevelSeven extends Level {
	boolean soundPlayed = false;
	boolean win = true;
	
	String[] ocText = new String[5];
	int[] ocX = new int[5];
	int[] ocY = new int[5];
	Color[] ocColor = new Color[5];
	
	public LevelSeven() {
		super(7, -5500000);
	}
	
	@Override
	public void checkForPitOpen() {
		ObjectCounter7 oc = null;
		for (int i = 0; i < renderables.size(); i++) {
			if (renderables.get(i) instanceof ObjectCounter7) {
				oc = (ObjectCounter7) renderables.get(i);
				if (!oc.wasActivated()) {
					win = false;
				}
			}
		}
		if (win) {
			Game.levelGround.setPitOpen(true);
			if (!soundPlayed) {
				soundPlayed = true;
				Game.playSound(0);
			}
			return;
		}
		win = true;
	}
	
	@Override
	public void updateGameObjects(EntityPlayer player) {
		for (int i = 0; i < renderables.size(); i++) {
			Renderable r = renderables.get(i);
			if (r instanceof GameObject) {
				GameObject go = (GameObject) r;
				if (go.isHeldByPlayer()) {
					go.setLogicX(player.getLogicX() + 8);
					go.updateRenderX();
					go.setY(player.getY() - 16);
				}
				go.updateRenderX();
				
				if (!go.isHeldByPlayer() && go.affectedByGravity()) {
					if (go.getY() < verticalCollide(go) - go.getImageHeight()) {
						go.setVerticalVelocity(go.getVerticalVelocity() - 0.25);
					}
					else {
						go.setVerticalVelocity(0.0);
					}
					go.updateHeight();
				}
				
			}
			if (r instanceof ObjectCounter7) {
				ObjectCounter7 oc = (ObjectCounter7) r;
				oc.countObjects();
				oc.getImage();
				if (oc.hasNumNeeded()) {
					ocColor[oc.instance] = Color.GREEN;
				}
				else {
					ocColor[oc.instance] = Color.RED;
				}
				ocText[oc.instance] = Integer.toString(oc.numNeeded - oc.count);
				ocX[oc.instance] = oc.getX() + 22;
				ocY[oc.instance] = oc.getY() + 20;
			}
			if (r instanceof Vacuum) {
				Vacuum v = (Vacuum) r;
				v.attractObjects();
			}
		}
		Game.render.addSpecialTextsToRender(ocX, ocY, ocText, ocColor);
	}
}