package john111898.ld29.level;

import java.util.ArrayList;

import john111898.ld29.Game;
import john111898.ld29.entity.EntityPlayer;
import john111898.ld29.render.Renderable;
import john111898.ld29.world.ClickableButton;
import john111898.ld29.world.GameObject;
import john111898.ld29.world.ObjectCounter;
import john111898.ld29.world.ObjectCounter6;
import john111898.ld29.world.Vacuum;

public class LevelSix extends Level {
	boolean soundPlayed = false;
	
	public int playerRadius = 150;
	
	public LevelSix() {
		super(6, -3000000);
	}
	
	@Override
	public void mouseClick(int x, int y, boolean leftClick) {
		for (int i = 0; i < renderables.size(); i++) {
			Renderable r = renderables.get(i);
			if (r instanceof ClickableButton) {
				ClickableButton cb = (ClickableButton) r;
				if (x > cb.getX() && x < cb.x2 && y > cb.getY() && y < cb.y2) {
					cb.click();
					switch(this.r.nextInt(2)) {
					case 0:
						Game.playSound(4);
						break;
					case 1:
						Game.playSound(5);
						break;
					case 2:
						Game.playSound(6);
						break;
					}
				}
			}
			else {
				if (r instanceof GameObject) {
					GameObject go = (GameObject) r;
					if ((x > go.getX() && x < go.x2 && y > go.getY() && y < go.y2) && go.canBePickedUp && (Math.sqrt(Math.pow((go.getX() - Game.player.getX()), 2) + (Math.pow(go.getY() - Game.player.getY(), 2))) < 150)) {
						go.setHeldByPlayer(!go.isHeldByPlayer());
						if (go.isHeldByPlayer()) {
							Game.playSound(1);
						}
						else {
							Game.playSound(2);
						}
					}
					else {
						if (go.isHeldByPlayer() && !leftClick) {
							if (Math.sqrt(Math.pow((go.getX() - x), 2) + (Math.pow(go.getY() - y, 2))) < 150) {
								go.setHeldByPlayer(false);
								go.setLogicX(x - (Game.WIDTH / 2) + go.getLogicX() - 24);
								go.updateRenderX();
								go.setY(y - 32);
								Game.playSound(2);
							}
						}
					}
					if ((x > go.getX() && x < go.x2 && y > go.getY() && y < go.y2) && go instanceof Vacuum) {
						Vacuum v = (Vacuum) r;
						v.rotateVacuum();
					}
				}
			}
		}
	}
	
	@Override
	public void checkForPitOpen() {
		ObjectCounter oc = null;
		for (int i = 0; i < renderables.size(); i++) {
			if (renderables.get(i) instanceof ObjectCounter6) {
				oc = (ObjectCounter6) renderables.get(i);
			}
		}
		if (oc != null) {
			oc.countObjects();
			if (oc.hasNumNeeded()) {
				Game.levelGround.setPitOpen(true);
				if (!soundPlayed) {
					soundPlayed = true;
					Game.playSound(0);
				}
			}
		}
	}
	
	@Override
	public int playerCollideSide(EntityPlayer p) {
		ArrayList<GameObject> check = getGameObjects();
		p.updateCollisionCoords(p.getX() + 8, p.getY());
		for (int i = 0; i < check.size(); i++) {
			GameObject test = check.get(i);
			test.updateCollisionCoords(test.getX(), test.getY());
			if (test.getCollisionBox().intersects(p.getCollisionBox())) {
				if (p.getX() < test.getX()) {
					return test.getX();
				}
				else {
					if (p.getX() > test.getX()) {
						return p.getX();
					}
				}
			}
		}
		return 0;
	}
}