package john111898.ld29.level;

import john111898.ld29.Game;
import john111898.ld29.entity.EntityPlayer;
import john111898.ld29.render.Renderable;
import john111898.ld29.world.GameObject;
import john111898.ld29.world.ObjectCounterOnlyAbove;

public class LevelTwo extends Level {
	boolean soundPlayed = false;
	
	int moveIndex = 0;
	
	public LevelTwo() {
		super(2, -1000);
	}
	
	@Override
	public void updateGameObjects(EntityPlayer player) {
		for (int i = 0; i < renderables.size(); i++) {
			Renderable r = renderables.get(i);
			if (r instanceof GameObject) {
				GameObject go = (GameObject) r;
				if (go.isHeldByPlayer()) {
					go.setLogicX(player.getLogicX() + 8);
					go.updateRenderX();
					go.setY(player.getY() - 16);
				}
				go.updateRenderX();
				
				if (!go.isHeldByPlayer() && go.affectedByGravity()) {
					if (go.getY() < verticalCollide(go) - go.getImageHeight()) {
						go.setVerticalVelocity(go.getVerticalVelocity() - 0.25);
					}
					else {
						go.setVerticalVelocity(0.0);
					}
					go.updateHeight();
				}
			}
			if (r instanceof ObjectCounterOnlyAbove) {
				ObjectCounterOnlyAbove oc = (ObjectCounterOnlyAbove) r;
				if (moveIndex == 0) {
					if (oc.getY() < 420 - 104) {
						oc.setY(oc.getY() + 64);
					}
					else {
						oc.setY(164 - 104);
					}
					moveIndex = 10;
				}
				else {
					moveIndex--;
				}
				oc.countObjects();
			}
		}
	}
	
	@Override
	public void checkForPitOpen() {
		ObjectCounterOnlyAbove oc = null;
		for (int i = 0; i < renderables.size(); i++) {
			if (renderables.get(i) instanceof ObjectCounterOnlyAbove) {
				oc = (ObjectCounterOnlyAbove) renderables.get(i);
			}
		}
		if (oc != null) {
			oc.countObjects();
			if (oc.hasNumNeeded()) {
				Game.levelGround.setPitOpen(true);
				if (!soundPlayed) {
					soundPlayed = true;
					Game.playSound(0);
				}
			}
		}
	}
}