package john111898.ld29.render;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import john111898.ld29.Game;

public class RenderComponent extends Component {
	private static final long serialVersionUID = 1L;
	
	BufferedImage[] images = new BufferedImage[1024];
	int[] x = new int[1024];
	int[] y = new int[1024];
	
	int renderNumber = 0;
	
	int level = 0;
	String specialText = "";
	int specialTextX = 0;
	int specialTextY = 0;
	Color specialTextColor = Color.black;
	
	String[] specialTexts = new String[] {"", "", "", "", ""};
	int[] specialTextsX = new int[] {0, 0, 0, 0, 0};
	int[] specialTextsY = new int[] {0, 0, 0, 0, 0};
	Color[] specialTextsColor = new Color[] {Color.black, Color.black, Color.black, Color.black, Color.black};
	
	public RenderComponent() {
		
	}
	
	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		for (int i = 0; i < images.length; i++) {
			g2.drawImage(images[i], x[i], y[i], null);
		}
		g2.setFont(new Font("Century Gothic", Font.PLAIN, 24));
		g2.drawString("Level " + level, 10, 30);
		if (Game.currentLevel != null) {
			g2.drawString("Elevation: " + Game.currentLevel.elevation + " m", 10, 60);
		}
		g2.setFont(new Font("Century Gothic", Font.PLAIN, 18));
		if (!specialText.equals("") && specialTexts[0].equals("")) {
			g2.setColor(specialTextColor);
			g2.drawString(specialText, specialTextX, specialTextY);
		}
		else {
			if (!specialTexts[0].equals("")) {
				for (int i = 0; i < 5; i++) {
					g2.setColor(specialTextsColor[i]);
					g2.drawString(specialTexts[i], specialTextsX[i], specialTextsY[i]);
				}
			}
		}
		g2.setColor(Color.white);
	}
	
	public void addImage(BufferedImage image, int x, int y) {
		images[renderNumber] = image;
		this.x[renderNumber] = x;
		this.y[renderNumber] = y;
		renderNumber++;
	}
	
	public void resetRenderNumber() {
		renderNumber = 0;
	}
	
	public void setLevelNumber(int levelNumber) {
		this.level = levelNumber;
	}
	
	public void addSpecialTextToRender(int x, int y, String text, Color c) {
		this.specialText = text;
		this.specialTextX = x;
		this.specialTextY = y;
		this.specialTextColor = c;
	}
	
	public void resetImages() {
		images = new BufferedImage[1024];
	}
	
	public void resetSpecialText() {
		specialText = "";
		resetSpecialTexts();
	}
	
	public void addSpecialTextsToRender(int[] x, int[] y, String[] text, Color[] c) {
		this.specialTexts = text;
		this.specialTextsX = x;
		this.specialTextsY = y;
		this.specialTextsColor = c;
	}
	
	public void resetSpecialTexts() {
		specialTexts = new String[] {"", "", "", "", ""};
	}
}