package john111898.ld29.world;

import java.awt.image.BufferedImage;

import john111898.ld29.Game;
import john111898.ld29.collision.CollisionBox;
import john111898.ld29.render.Renderable;

public class GameObject implements Renderable {
	int x = 0;
	int y = 0;
	BufferedImage image;
	boolean heldByPlayer = false;
	
	public int x2;
	public int y2;
	
	int logicX;
	
	double verticalVelocity = 0.0;
	boolean affectedByGravity = false;
	
	public boolean canBePickedUp = false;
	
	CollisionBox collision;
	
	String extraInfo = "";
	
	public GameObject(int x, int y, BufferedImage image, boolean canBePickedUp) {
		this.x = x;
		this.y = y;
		this.image = image;
		
		x2 = x + image.getWidth();
		y2 = y + image.getHeight();
		
		logicX = x;
		
		this.canBePickedUp = canBePickedUp;
		collision = createCollisionBox();
	}
	
	public GameObject(int x, int y, BufferedImage image, boolean canBePickedUp, String info) {
		this.x = x;
		this.y = y;
		this.image = image;
		
		x2 = x + image.getWidth();
		y2 = y + image.getHeight();
		
		logicX = x;
		
		this.canBePickedUp = canBePickedUp;
		collision = createCollisionBox();
		
		extraInfo = info;
	}
	
	@Override
	public int getX() {
		return x;
	}

	@Override
	public int getY() {
		return y;
	}

	@Override
	public BufferedImage getImage() {
		return image;
	}
	
	public void setHeldByPlayer(boolean h) {
		heldByPlayer = h;
	}
	
	public boolean isHeldByPlayer() {
		return heldByPlayer;
	}
	
	public void setX(int x) {
		this.x = x;
		x2 = x + image.getWidth();
	}
	
	public void setY(int y) {
		this.y = y;
		y2 = y + image.getHeight();
	}
	
	public int getLogicX() {
		return logicX;
	}
	
	public void setLogicX(int logicX) {
		this.logicX = logicX;
	}
	
	public void updateRenderX() {
		setX(logicX - Game.player.getLogicX() + Game.player.renderX);
	}
	
	public void setVerticalVelocity(double vv) {
		verticalVelocity = vv;
	}
	
	public double getVerticalVelocity() {
		return verticalVelocity;
	}
	
	public void updateHeight() {
		setY((int) (getY() - verticalVelocity));
	}
	
	public int getImageHeight() {
		return image.getHeight();
	}
	
	public void setAffectedByGravity(boolean g) {
		affectedByGravity = g;
	}
	
	public boolean affectedByGravity() {
		return affectedByGravity;
	}
	
	public CollisionBox createCollisionBox() {
		double width = image.getWidth();
		double height = image.getHeight();
		return new CollisionBox(width, height);
	}
	
	public void updateCollisionCoords(int x, int y) {
		collision.x = x;
		collision.y = y;
	}
	
	public CollisionBox getCollisionBox() {
		return collision;
	}
	
	public String getExtraInfo() {
		return extraInfo;
	}
}