package john111898.ld29.world;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.util.ArrayList;

import john111898.ld29.Game;
import john111898.ld29.render.Renderable;

public class ObjectCounter extends GameObject implements Renderable {
	int count = 0;
	int numNeeded = 0;
	
	public ObjectCounter(int x, int y, BufferedImage image, int numNeeded) {
		super(x, y, image, false);
		this.numNeeded = numNeeded;
	}
	
	public void countObjects() {
		count = 0;
		ArrayList<GameObject> gameObjects = Game.currentLevel.getGameObjects();
		for (GameObject e : gameObjects) {
			if ((e.x > this.x && e.x2 < this.x2) || (e.x < this.x && e.x2 > this.x) || (e.x < this.x2 && e.x > this.x)) {
				count++;
			}
		}
	}
	
	public boolean hasNumNeeded() {
		return count >= numNeeded;
	}
	
	@Override
	public BufferedImage getImage() {
		if (hasNumNeeded()) {
			Game.addSpecialTextToRender(x + 22, y + 20, Integer.toString(numNeeded - count), Color.GREEN);
			return Game.images[10];
		}
		Game.addSpecialTextToRender(x + 22, y + 20, Integer.toString(numNeeded - count), Color.RED);
		return Game.images[9];
	}
}